from graphWithPrevious import LinkedDirectedGraphPrevious
from graphWithPrevious import LinkedVertexPrevious
import algorithms


def buildGraph(fileName):

    g = LinkedDirectedGraphPrevious()
    d = {}
    edges = []

    wfile = file(fileName)
    wordLength = int(wfile.readline().rstrip('\n'))
    # create buckets of words that differ by one letter.
    for line in wfile:
        word = line[0:wordLength]
        g.addVertex(word)
        for i in range(wordLength):
            bucket = word[0:i] + '_' + word[i+1:wordLength]
            if d.has_key(bucket):
                d[bucket].append(word)
            else:
                d[bucket] = [word]


    # add vertices and edges for words in the same bucket.
    for i in d.keys():
        for j in d[i]:
            for k in d[i]:
                if j != k:
                    edges.append((j,k))
                    if not g.containsEdge(j,k):
                        g.addEdge(j,k,1)
                    if not g.containsEdge(k,j):
                        g.addEdge(k,j,1)
    return g

g = buildGraph('words.dat')

algorithms.bfs(g,g.getVertex("fool"))

previousTraversalList = g.traversePrevious("sage")
print '\n Previous traversal: ', previousTraversalList
previousTraversalList.reverse()
print '\n Word Ladder:', previousTraversalList


